config/routes.rb
Rails.application.routes.draw do
  resources :rooms do
    resources :users, shallow: true
  end
  get 'rooms/:room_id/users/bulk', to: 'users#bulk', as: 'bulk_new_room_users'
  post 'rooms/:room_id/users/bulk', to: 'users#create_bulk', as: 'bulk_create_room_users'
  post 'rooms/:room_id/users/:id/test_invite', to: 'users#test_invite', as: 'test_invite_user'
  post 'rooms/:room_id/users/invite', to: 'users#invite', as: 'invite_room_users'
  delete 'rooms/:room_id/users', to: 'users#destroy_all', as: 'destroy_room_users'
  delete 'rooms/:room_id/users/invite', to: 'users#uninvite', as: 'uninvite_room_users'
  post 'rooms/:room_id/users/mark_invited', to: 'users#mark_invited', as: 'mark_invited_room_users'
  get 'rooms/:id/aanwezig.csv', to: 'rooms#present', as: 'room_present_users'
  get ':token/aanwezig.csv', to: 'main#users'
  get ':token/stream', to: 'main#stream'
  get ':token', to: 'main#join', as: 'join_room'
  root 'main#index'
end

app/models/room.rb
class Room < ApplicationRecord
  has_many :users, dependent: :destroy
end

app/controllers/rooms_controller.rb
class RoomsController < ApplicationController
  http_basic_authenticate_with name: Rails.application.config.admin_name,
                               password: Rails.application.config.admin_password

  before_action :set_room, only: [:show, :edit, :update, :destroy, :present]

  # GET /rooms
  # GET /rooms.json
  def index
    @rooms = Room.all
  end

  # GET /rooms/1
  # GET /rooms/1.json
  def show
  end

  # GET /rooms/new
  def new
    @room = Room.new

    meetings = bbb_server.get_meetings[:meetings]
    if meetings.length > 0
      meeting = meetings.first
      @room.name = meeting[:meetingName]
      @room.meeting = meeting[:meetingID]
      @room.attendee_pw = meeting[:attendeePW]
      @room.moderator_pw = meeting[:moderatorPW]
    end
  end

  # GET /rooms/1/edit
  def edit
  end

  # POST /rooms
  # POST /rooms.json
  def create
    @room = Room.new(room_params)

    respond_to do |format|
      if @room.save
        format.html { redirect_to rooms_url, notice: 'Room was successfully created.' }
        format.json { render :show, status: :created, location: @room }
      else
        format.html { render :new }
        format.json { render json: @room.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /rooms/1
  # PATCH/PUT /rooms/1.json
  def update
    respond_to do |format|
      if @room.update(room_params)
        format.html { redirect_to rooms_url, notice: 'Room was successfully updated.' }
        format.json { render :show, status: :ok, location: @room }
      else
        format.html { render :edit }
        format.json { render json: @room.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /rooms/1
  # DELETE /rooms/1.json
  def destroy
    @room.destroy
    respond_to do |format|
      format.html { redirect_to rooms_url, notice: 'Room was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  # GET /rooms/1/aanwezig
  # GET /rooms/1/aanwezig.csv
  def present
    require 'csv'
    conference = Set.new()
    if bbb_server.is_meeting_running?(@room.meeting)
      bbb_server.get_meeting_info(@room.meeting, @room.moderator_pw)[:attendees].each do |attendee|
        conference.add(attendee[:userID].to_i)
      end
    end
    csv_data = CSV.generate do |csv|
      User.where(room_id: @room.id).each do |attendee|
        if not attendee.proxy and (attendee.presence or conference === attendee.id)
          if attendee.vote and voter = attendee
            csv << [voter.id, voter.email, voter.name]
          end
          User.where(email: attendee.email, vote: true, proxy: true, room_id: @room.id).each do |proxy|
            csv << [proxy.id, proxy.email, "gemachtigde voor #{proxy.name}"]
          end
        end
      end
    end

    respond_to do |format|
      format.csv { send_data csv_data, filename: "#{@room.name} #{Time.zone.now}.csv" }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_room
      @room = Room.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def room_params
      params.require(:room).permit(:name, :meeting, :attendee_pw, :moderator_pw, :email_subject, :email_body)
    end
end

app/helpers/rooms_helper.rb
module RoomsHelper
end

app/views/rooms/_form.html.erb
<%= form_with(model: room, local: true) do |form| %>
  <% if room.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(room.errors.count, "error") %> prohibited this room from being saved:</h2>

      <ul>
        <% room.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="field">
    <%= form.label :meeting %>
    <%= form.text_field :meeting %>
  </div>

  <div class="field">
    <%= form.label :attendee_pw %>
    <%= form.text_field :attendee_pw %>
  </div>

  <div class="field">
    <%= form.label :moderator_pw %>
    <%= form.text_field :moderator_pw %>
  </div>

  <div class="field">
    <%= form.label :email_subject %>
    <%= form.text_field :email_subject %>
  </div>

  <div class="field">
    <%= form.label :email_body %>
    <%= form.text_area :email_body, :size => "100x30" %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/rooms/edit.html.erb
<h1>Editing Room</h1>

<%= render 'form', room: @room %>

<%= link_to 'Show', @room %> |
<%= link_to 'Back', rooms_path %>

app/views/rooms/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Rooms</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Meeting</th>
      <th>Attendee pw</th>
      <th>Moderator pw</th>
      <th>Email Subject</th>
      <!--<th>Email Body</th>-->
      <th colspan="4"></th>
    </tr>
  </thead>

  <tbody>
    <% @rooms.each do |room| %>
      <tr>
        <td><%= room.name %></td>
        <td><%= room.meeting %></td>
        <td><%= room.attendee_pw %></td>
        <td><%= room.moderator_pw %></td>
        <td><%= room.email_subject %></td>
        <!--<td><%= room.email_body %></td>-->
        <!--<td><%= link_to 'Show', room %></td>-->
        <td><%= link_to 'Users', room_users_path(room) %></td>
        <td><%= link_to 'Present Users', room_present_users_path(room) %></td>
        <td><%= link_to 'Edit', edit_room_path(room) %></td>
        <td><%= link_to 'Destroy', room, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Room', new_room_path %>

app/views/rooms/new.html.erb
<h1>New Room</h1>

<%= render 'form', room: @room %>

<%= link_to 'Back', rooms_path %>

app/views/rooms/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @room.name %>
</p>

<p>
  <strong>Meeting:</strong>
  <%= @room.meeting %>
</p>

<p>
  <strong>Attendee pw:</strong>
  <%= @room.attendee_pw %>
</p>

<p>
  <strong>Moderator pw:</strong>
  <%= @room.moderator_pw %>
</p>

<p>
  <strong>Email Subject:</strong>
  <%= @room.email_subject %>
</p>

<p>
  <strong>Email Body:</strong>
  <%= @room.email_body %>
</p>

<%= link_to 'Show Users', room_users_path(@room) %> |
<%= link_to 'Edit', edit_room_path(@room) %> |
<%= link_to 'Present Users', room_present_users_path(@room) %> |
<%= link_to 'Back', rooms_path %>